﻿using System;
using System.IO;
using System.Reflection;
using System.Resources;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;

namespace uBIM.Checker.AOP
{
    internal partial class AboutForm : Form
    {
        private const string key_a = "<RSAKeyValue><Modulus>oNr4T8oRvbqOtswFcRI0jlhy15IUJ6Mi8bHWAyW/bVxPxj3Lga2ZhYgwqA01fLcNfO9tPq63Vfxksbw4p7V5+GzAsYhS1Hs6QGzilKiZB2jjjKSctWTZZCfcURVGsQLcKDz1JlMbT8/M8mNbgIzKI6UiXtxBiWFf8POLoOk5z1s=</Modulus><Exponent>AQAB</Exponent><P>2F+DlaY2KPUUoMwgyauR92ZnGEdrCL1+9YtEQLiQ5f/EkkosVy3rdCF+39b6uP5puzqvb7QftuWL0aTLBcEnoQ==</P><Q>vlCMj5gv+fDAOdOsz1Ma8JRe2R8TcSN22vx63tvrA5gvxgfFPzume/WJRADNtCzfklkGrOXmit80vfgxN0Glew==</Q><DP>w8+keFCj4OryURaKcZeoEDmHAQzYy18aP0JacSvWTZ7qmO0xNXAkDcOmWxHlcnci3kKcs71RmiYgI4g8BygnIQ==</DP><DQ>Doi+Q1UfDNp7A6+LugWhwA/EspYx+Oj5cb3ocE6hQxQDSf9b6/lVPJBC3GOnUgQ/SsDrxpaEJcToFT34HD0yMw==</DQ><InverseQ>MlY+l+X4Nu++oHi/UeSuNVKB3uKTCG3q2rq/fJa5HpOmrwrAblOT50HWb/4DOzp4t/2vKuq92yf4iLokVWMt0A==</InverseQ><D>ZMpwN0bNsQ25qQ7UBhK7PcpsQ2l0GZYeKkYdbKF1fmgOUJCd+Oa3QLWij1qffkMRP4yi7lj55fYdfkULVwLepm1hxE5aGf5c/36JO0QqmrUVppPaz7SR8EnmYwMKJD1tv/puzXfDA8+upFYiCfg+SF/+svxMUVw3mK21dhe27EE=</D></RSAKeyValue>";
        private const string key_b = "<RSAKeyValue><Modulus>wK0zy1DkjYBpu9rzXzP9ScqWfxfAv5mOUtbf1Hom4BJREYBoXuRh3kqu8HQuT9nO2/o8nDi52vAJKHVZPZKrKNifYLOAHj4gWIO8qYrWrR9wAYTvhM/cLxXrs3/C3sflCny4A0QPnbkzpDJo/lGaybUpEDG2SNMBYVRO/TVQ5N0=</Modulus><Exponent>AQAB</Exponent><P>6RP6kmHLZARPM1r2VTnDb6z4AoWgqzrgMs5fVzYcqjo/50mXYgjgegf7EvhehCbOUTQwjB/EvS/s3xzgBCpE0w==</P><Q>06ARVWAid/k61Q7C7dBOW7Dz0SXXdql+OuxcwnVOo0lg1+R+m1zWTYDPB4DUqCr9foNHbMz095/zufWnAY3hjw==</Q><DP>o5l7ax4rtmNz+Dcj6sRl0tBVMOf809O6pM7Iix2XV0EVs9Gq6YwTjHRnnnQpW5clgEgiv2hZHvYxzJWnBCVrMw==</DP><DQ>WB89WInRkJfNsc6VySWGm5PR03OohxcJI0wtTCRA/KmflAbn2ZYM/vT2QK+a3fQY3seXxGyMTVjjyrnKM1F7bQ==</DQ><InverseQ>yqPGPSBXIG8FF3m0Rk4doXNcE1ljUeKSZCOo0iblfH4DYrBOIKg9+YQn9F5mA045IFZxMyXoSGZw0BLSEfA/pQ==</InverseQ><D>ruAE9HHVHsEANmpBHZV4PHNNKMkMPlpGnNU9jgHYKuM1BSeAky/BzBoIsWEhb4QGhg2W2Ut7FEVsanYnqwTlprdmXi4VzqAjazjvS/o+sHQbfejIFKIJHC6rUsAsZLkclPZcqyjJqDyLjyrOj5ilqRuIgFp6RhVnZKmL9NC6V5k=</D></RSAKeyValue>";
        private string _title;
        public AboutForm(string title)
        {
            InitializeComponent();
            _title = title;
            string[] temp = Common.AssemblyFileVersion().Split('.');
            linkLabel_Version.Text = $"版本：20{temp[1]}";
            this.Text = $"{_title} - 关于";
            this.label2.Text = $"{_title}";
        }


        private void HelpForm_Load(object sender, EventArgs e)
        {
            this.label_Info.Text = string.Format("内部版本：{0}\r\n广州优比建筑咨询有限公司\r\nhttp://www.u-bim.com", Common.AssemblyFileVersion());
            RefreshActivateState();
        }

        private void linkLabel_ActivateState_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            LicenseChecker.Instance.Checker.Activate($"{_title}"
             , Common.GetDeviceCode()
             , string.Format("={0}=", Common.GetMd5Hash("|><=><|"))
             , key_a
             , key_b);
            RefreshActivateState();
            Task.Run(() =>
            {
                Task.Delay(5000).Wait();
                //激活成功
                if (!LicenseChecker.Instance.Checker.OutLimit && LicenseChecker.Instance.Checker.LimitDate != DateTime.MinValue)
                {
                    DateTime nowTime = uBIM.Utils.General.GetNetTime();
                    if (nowTime == DateTime.MinValue)
                    {
                        nowTime = DateTime.Now;
                    }
                    string strEncrypt;
                    //根据有效期天数是否是试用激活
                    if (LicenseChecker.Instance.Checker.LimitDate <= nowTime.Date.AddDays(5))
                    {
                        //试用
                        strEncrypt = uBIM.Utils.DESHelper.EncryptDES($"{_title}*{Common.GetDeviceCode()}*0");
                    }
                    else
                    {
                        //非试用
                        strEncrypt = uBIM.Utils.DESHelper.EncryptDES($"{_title}*{Common.GetDeviceCode()}*1");
                    }
                    //往磁盘写入是否试用标识信息
                    Common.WirteStringData(strEncrypt, Common.TRY_INFO_FILE_PATH);
                }
                if (!IsClosed())
                {
                    this.BeginInvoke((Action)RefreshActivateState);
                }
            });
        }

        private bool IsClosed()
        {
            bool result = true;
            foreach (Form form in Application.OpenForms)
            {
                if (form.Name == this.Name)
                {
                    result = false;
                    break;
                }
            }
            return result;
        }

        private void RefreshActivateState()
        {
            if (LicenseChecker.Instance.Checker.OutLimit || LicenseChecker.Instance.Checker.LimitDate == DateTime.MinValue)
            {
                this.linkLabel_ActivateState.Enabled = true;
                if (LicenseChecker.Instance.Checker.LimitDate == DateTime.MinValue)
                {
                    this.linkLabel_ActivateState.Text = "未激活";
                }
                else
                {
                    if (LicenseChecker.Instance.Checker.OutLimit || DateTime.Now.Date > LicenseChecker.Instance.Checker.LimitDate)
                    {
                        this.linkLabel_ActivateState.Text = string.Format("{0}\r\n有效期至：{1}", "已过期", LicenseChecker.Instance.Checker.LimitDate.ToString("yyyy-MM-dd"));
                    }
                }
            }
            else
            {
                this.linkLabel_ActivateState.Text = string.Format("{0}\r\n有效期至：{1}", "已激活", LicenseChecker.Instance.Checker.LimitDate.ToString("yyyy-MM-dd"));
                this.linkLabel_ActivateState.Enabled = false;
            }
        }


        private void linkLabel_Version_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
        }

        private int sumMouseDown;
        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            if ((ModifierKeys & Keys.Control) == Keys.Control)
            {
                if (!LicenseChecker.Instance.CheckLicenseState(_title, false))
                {
                    return;
                }

                sumMouseDown++;
                if (sumMouseDown == 3)
                {
                    if (DialogResult.Yes == MessageBox.Show("确定需要注销激活吗？", $"{_title} - 注销", MessageBoxButtons.YesNo, MessageBoxIcon.Question))
                    {
                        if (LicenseChecker.Instance.Checker.UnActivate($"{_title}"))
                        {
                            this.Close();
                        }
                    }
                    sumMouseDown = 0;
                }
            }
            else
            {
                sumMouseDown = 0;
            }
        }
    }
}
